WFS 1.0.0 Client requests with a GML component fail against Geoserver (lack namespace)
Category: Web Services clients/WFS

Affected QGIS version:master Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 21135
Description

WEFS 1.0.0 Client requests made from QGIS 2.8.1 will fail against Geoserver (tested on 2.7.1) if the request contains a Filter that uses
geometries.

From the WFS log console:

DescribeFeatureType failed for url
http://localhost:8080/geoserver/ows?SERVICE=WFS&VERSION=1.0.0&REQUEST=GetFeature&TYPENAME=xxxx:yyyy&SRSNAME
AME=EPSG:4326&FILTER=<ogc:Filter xmIns:ogc="http://www.opengis.net/ogc">
<ogc:Intersects>
<ogc:PropertyName>geometry</ogc:PropertyName>
<gml:Point>
<gml:coordinates cs="," ts=" ">-91.5,34.5</gml:coordinates>
</gml:Point>
</ogc:Intersects>
</ogc:Filter>

Note that the Filter's opening XML tag includes the "ogc" namespace, but it never defines the "gml" namespace.
My naive attempt at debugging: | see that geometryFromGML is overloaded in

https://github.com/qgis/QGIS/blob/master/src/core/qgsogcutils.cpp. Only one of them contains logic to set the "gml" namespace, and |
suspect that the qgswfsprovider.cpp might be invoking the wrong one.

Related issues:
Related to QGIS Application - Bug report # 6552: WFS client: Filter Element c... Closed 2012-10-21

F=EPS(

History

#1 - 2015-07-07 01:22 PM - Jeff G

For context, in the above case, | had used the expression string builder to issue the filter:
intersects($geometry, geomFromWKT('POINT(-91.5 34.5)"))

The geoserver-side error is:

org.geoserver.platform.ServiceException: org.xml.sax.SAXException: Attempted to construct illegal filter - | dont understand the tag: gml:Point. HINT: tags

are case-sensitive!

#2 - 2015-12-22 07:27 AM - Médéric RIBREUX
- Affected QGIS version changed from 2.8.1 to master
https://github.com/qgis/QGIS/blob/master/src/core/qgsogcutils.cpp

- Status changed from Open to Feedback

Hello, bug triage...
this is also true for an attribute filter (tested on QGIS 2.13 master):
DescribeFeatureType failed for url
http://geoservices.brgm.fr/geologie?SERVICE=WFS&VERSION=1.0.0&REQUEST=GetFeature&TYPENAME=MINES_EMP&SRSNAME=EPSG:4326&FILTE
:4326&FILTER=<ogc:Filter xmIns:ogc="http://www.opengis.net/ogc">
<ogc:PropertylsEqualTo>
<ogc:PropertyName>substance</ogc:PropertyName>
<ogc:Literal>Pb</ogc:Literal>

</ogc:PropertylsEqualTo>
</ogc:Filter>

#3 - 2016-01-06 11:49 AM - Giovanni Manghi
- Status changed from Feedback to Open

#4 - 2017-01-17 06:21 AM - Giovanni Manghi

- Status changed from Open to Feedback

This must be re-tested with qgis 2.18.*/master as the wfs client has been overhalued meanwhile.

#5 - 2017-03-06 02:22 PM - Giovanni Manghi

Can anyone advice about the necessary steps to try replicate this issue?

#6 - 2017-04-18 08:05 PM - Jeff G
- Status changed from Feedback to Closed

Now using QGIS 2.18.4, | have tried both the "intersects" and the "attribute" test cases mentioned earlier in this issue, and they both work as expected.

This appears to be fixed. Thank you!
